Subject: Re: bug#60943: 28.2; ‘tramp-handle-file-regular-p’ misses symlinks

From: Greg Pfeil <[email-masked]>
Date: Thu, 19 Jan 2023 10:55:45 -0700

I think sockets (where the 0th char is ?s) are also considered regular files. Also, I think that patch checks whether the truename is a regular file, but I believe /all/ symlinks are considered regular.

How about this version?

It just changes the equality check to check for the set of valid values. If we had the mode as a number, we could just check the one bit for regular files (which I think is what ‘file-regular-p’ does).

> On Jan 19, 2023, at 06:12, Michael Albinus <[email-masked]> wrote:
> 
> Greg Pfeil <[email-masked]> writes:
> 
> Hi Greg,
> 
>> I was having an issue where .dir-locals.el on remote machines weren’t getting picked up when they were a symlink. Local symlinks worked fine, and remote non-symlinks also worked.
>> 
>> Digging in, ‘tramp-handle-regular-file-p’ explicitly checks that the first character in ‘file-attribute-mode’ is ?-. However, for symlinks, that character will be ?l.
>> 
>> Modifying ‘dir-locals--all-files’ to check
>> 
>>  (or (file-regular-p f) (file-symlink-p f))
>> 
>> \(which is ostensibly redundant) instead of simply
>> 
>>  (file-regular-p f)
> 
> Indeed, there's a bug. Thanks for the report!
> 
>> fixes the behavior, since TRAMP will now check with both ‘tramp-handle-file-regular-p’ and ‘tramp-handle-file-symlink-p’. The correct fix is to make ‘tramp-handle-file-regular-p’ match the behavior of ‘file-regular-p’.
> 
> The appended patch fixes this. Eli, is it OK to push to the emacs-29 branch?
> 
> Best regards, Michael.
> 
> <Mail Attachment>